import { EntityRepository, Repository } from "typeorm";
import { HomePageDiscoverSectionCmsEntity } from "./entities/home-page-discover-section-cms.entity";
import { UpdateHomePageDiscoverSectionCmsDto } from "./dto/update-home-page-discover-section-cms.dto";

@EntityRepository(HomePageDiscoverSectionCmsEntity)
export class HomePageDiscoverSectionCmsRepository extends Repository<HomePageDiscoverSectionCmsEntity> {

    async createEntity(dto: UpdateHomePageDiscoverSectionCmsDto): Promise<HomePageDiscoverSectionCmsEntity | Error> {
        try {
            const entity = this.create({
                sectionTitle: dto.sectionTitle,
                imageOne: dto.imageOne,
                headingOne: dto.headingOne,
                titleOne: dto.titleOne,
                buttonTextOne: dto.buttonTextOne,
                buttonLinkOne: dto.buttonLinkOne,
                imageTwo: dto.imageTwo,
                headingTwo: dto.headingTwo,
                titleTwo: dto.titleTwo,
                buttonTextTwo: dto.buttonTextTwo,
                buttonLinkTwo: dto.buttonLinkTwo,
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async updateEntity(dto: UpdateHomePageDiscoverSectionCmsDto, id: string): Promise<HomePageDiscoverSectionCmsEntity | Error> {
        try {
            await this.update(id, {
                sectionTitle: dto.sectionTitle,
                imageOne: dto.imageOne,
                headingOne: dto.headingOne,
                titleOne: dto.titleOne,
                buttonTextOne: dto.buttonTextOne,
                buttonLinkOne: dto.buttonLinkOne,
                imageTwo: dto.imageTwo,
                headingTwo: dto.headingTwo,
                titleTwo: dto.titleTwo,
                buttonTextTwo: dto.buttonTextTwo,
                buttonLinkTwo: dto.buttonLinkTwo,
            });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<HomePageDiscoverSectionCmsEntity[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}