import {Body, Controller, Get, HttpCode, HttpStatus, Post, UseGuards} from "@nestjs/common";
import {AdminAuthGuard} from "src/core/guards/admin-auth.guard";
import {Constants} from "src/utils/constants";
import { HomePageTestimonialSectionCmsService } from "./home-page-testimonial-section-cms.service";
import { UpdateHomePageTestimonialSectionCmsDto } from "./dto/update-home-page-testimonial-section-cms.dto";

@Controller({path: "home-page-testimonial-section-cms", version: Constants.API_VERSION_1})

export class HomePageTestimonialSectionCmsController {
    constructor(private readonly service: HomePageTestimonialSectionCmsService) {
    }

    @Post()
    @HttpCode(HttpStatus.OK)
    @UseGuards(AdminAuthGuard)
    updateOrCreateData(
        @Body() dto: UpdateHomePageTestimonialSectionCmsDto
    ) {
        return this.service.updateOrCreateData(dto);
    }

    @Get()
    // @UseGuards(AdminAuthGuard)
    findAll() {
        return this.service.findAll();
    }
}
