import { Module } from '@nestjs/common';
import { TypeOrmModule } from '@nestjs/typeorm';
import { JwtModule } from '@nestjs/jwt';
import JwtConfigService from 'src/core/jwt/jwt-config.service';
import JwtHelper from 'src/core/jwt/jwt.helper';
import { UsersRepository } from 'src/modules/users/user.repository';
import { UpsConfigurationRepository } from './ups-configuration.repository';
import { UpsConfigurationController } from './ups-configuration.controller';
import { UpsConfigurationService } from './ups-configuration.service';

@Module({
    imports: [
        JwtModule.registerAsync({
            useClass: JwtConfigService
        }),
        TypeOrmModule.forFeature([UsersRepository]),
        TypeOrmModule.forFeature([UpsConfigurationRepository])
    ],
    controllers: [UpsConfigurationController],
    providers: [UpsConfigurationService, JwtHelper]
})
export class UpsConfigurationModule {}